package rice.pastry.socket;


/**
 * Interface which represents an object interested in hearing the result
 * of a ping.  The pingResponse() method will be called only if and when
 * a ping is heard back from.
 *
 * @version $Id: PingResponseListener.java 2972 2006-01-30 15:31:20Z jeffh $
 * @author amislove
 */
public interface PingResponseListener {
  
  /**
   * Method which is called once a previously-issued ping is
   * responded to.
   *
   * @param path The path of the ping
   * @param RTT The round-trip-time along the path
   * @param timeHeardFrom The time at which the response was received.
   */
  public void pingResponse(SourceRoute path, long RTT, long timeHeardFrom);
  
}
